<?php
/**
 * Saving process using ajax method
 *
 * @return void
 */
if ( !function_exists( 'do_ajax_save' ) ) {
	function do_ajax_save() {
		$aft_save_data = array(
			'post_id' 					=> $_POST['post_id'],
			'user_type'					=> ( !is_user_logged_in() ) ? 0 : 1,
			'session_key'				=> $_POST['session_key'],
			'trustworthy_rate' 			=> $_POST['trustworthy_rate'],
			'objective_rate' 			=> $_POST['objective_rate'],
			'complete_rate' 			=> $_POST['complete_rate'],
			'wellwritten_rate' 			=> $_POST['wellwritten_rate'],
			'is_highly_knowledgable' 	=> $_POST['is_highly_knowledgable'],
			'is_relevant' 				=> $_POST['is_relevant'],
			'is_my_profession' 			=> $_POST['is_my_profession'],
			'is_personal_passion' 		=> $_POST['is_personal_passion'],
			'rate_date'					=> $_POST['rate_date'],
			'is_page'					=> $_POST['is_page'],
		);
			
		$isnew = ( empty( $_POST['rate_date'] ) ) ? true : false;
		$post_id = $aft_save_data['post_id'];
		$session_key = $aft_save_data['session_key'];
		
		aft_plgn_save_ratings( $isnew, $aft_save_data, $post_id, $session_key );
		die();
	}
}

/**
 * Display the plugin in a content
 *
 * @param content - The content of the site.
 *
 * @return content
 */
if ( !function_exists( 'aft_plgn_display_page' ) ) {
	function aft_plgn_display_page( $content ) {
		$aft_options_array = get_option( 'aft_options_array' );
		$aft_options_by_array = get_option( 'aft_options_by_array' );
		
		$aft_is_enable = $aft_options_array['aft_is_enable'];
		$aft_location = $aft_options_array['aft_location'];
		$aft_insertion = $aft_options_array['aft_insertion'];
		$options_category = $aft_options_by_array['category'];
		$options_page = $aft_options_by_array['page'];
		
		$postid = get_the_id();
			
		if ( !is_user_logged_in() ) {
			//session_key for guest/visitor must be cookie variable.
			$session_key = $_COOKIE[ RTP_COOKIE_NAME ];
		} else {
			//session_key must be the combined 'user-ID of logged user' for registered user.
			$session_key = 'user-' . get_current_user_id();
		}
		
		$aft_data = aft_plgn_fetch_ratings( $postid, $session_key, ( is_page() ) ? 'true' : 'false' );		
		?>
		<style type='text/css'>
		#rtp-loading {
			background:url(<?php echo RTP_PLUGIN_DIR_IMG; ?>success.png) left top no-repeat;
			text-align: left;
			font-size: 11px;
			color: #FF0000;
			height: 15px;
			padding-top: 11px;
			padding-left: 30px;
			display: none;
			font-family:Verdana, Arial, Helvetica, sans-serif; 
		}
		</style>
		<?php		
		$display = '<!--Main Content-->
					<div class="feedback">
						<div class="feedback-panel">
							<div class="feedback-buffer">
								<div class="feedback-title">Rate this article:</div>
								<div style="clear:both;"></div>
								<!--Primary Feedback-->
								<div class="feedback-rating">
									<div class="feedback-ratings">
										<div class="feedback-label">Trustworthy</div>
										<div id="feedback-trustworthy">
											<input type="hidden" id="feedback-trustworthy-val" name="trustworthy-score" value="'.$aft_data->trustworthy_rate.'" />
										</div>
										<div class="feedback-trustworthy-hint"></div>
									</div>
									<div class="feedback-ratings">
										<div class="feedback-label">Objective</div>
										<div id="feedback-objective">
											<input type="hidden" id="feedback-objective-val" name="objective-score" value="'.$aft_data->objective_rate.'" />
										</div>
										<div class="feedback-objective-hint"></div>
									</div>
									<div class="feedback-ratings">
										<div class="feedback-label">Complete</div>
										<div id="feedback-complete">
											<input type="hidden" id="feedback-complete-val" name="complete-score" value="'.$aft_data->complete_rate.'" />
										</div>
										<div class="feedback-complete-hint"></div>
									</div>
									<div class="feedback-ratings">
										<div class="feedback-label">Well-written</div>
										<div id="feedback-wellwritten">
											<input type="hidden" id="feedback-wellwritten-val" name="wellwritten-score" value="'.$aft_data->wellwritten_rate.'" />
										</div>
										<div class="feedback-wellwritten-hint"></div>
									</div>
								</div>
								<div style="clear:both;"></div>
								<!--For Feedback Options-->
								<div class="feedback-options">
									<div class="feedback-options-selection">';
						if ( $aft_data->is_highly_knowledgable == 'true' ) {
							$display .= '<input id="feedback-options-general" type="checkbox" name="feedback-general" value="true" checked="checked" />';
						} else {
							$display .= '<input id="feedback-options-general" type="checkbox" name="feedback-general" value="false" />';
						}
						$display .=		'<label class="feedback-label" for="feedback-options-general">I am highly knowledgeable about this topic (optional)</label>
									</div>
									<div class="feedback-helpimprove">';
						if ( $aft_data->is_highly_knowledgable == 'true' ) {
							$display .=	'<div class="feeback-helpimprove-hidden" style="display:block;">';
						} else {
							$display .=	'<div class="feeback-helpimprove-hidden" style="display:none;">';
						}
						$display .=			'<ul>
												<li>';
									if ( $aft_data->is_relevant == 'true' ) {	
										$display .=	'<input id="feedbackStudies" type="checkbox" name="feedback-studies" value="true" checked="checked" />';
									} else {
										$display .=	'<input id="feedbackStudies" type="checkbox" name="feedback-studies" value="false" />';
									}
									$display .=		'<label class="feedback-label" for="feedbackStudies">I have a relevant college/university degree</label>
												</li>
												<li>';
									if ( $aft_data->is_my_profession == 'true' ) {	
										$display .=	'<input id="feedbackProfession" type="checkbox" name="feedback-profession" value="true" checked="checked" />';
									} else {
										$display .=	'<input id="feedbackProfession" type="checkbox" name="feedback-profession" value="false" />';
									}
									$display .=		'<label class="feedback-label" for="feedbackProfession">It is part of my profession</label>
												</li>
												<li>';
									if ( $aft_data->is_personal_passion == 'true' ) {
										$display .=	'<input id="feedbackPassion" type="checkbox" name="feedback-passion" value="true" checked="checked" />';
									} else {
										$display .=	'<input id="feedbackPassion" type="checkbox" name="feedback-passion" value="false" />';
									}
									$display .=		'<label class="feedback-label" for="feedbackPassion">It is a deep personal passion</label>
												</li>
											<ul>
										</div>
									</div>
									<div class="buttonwrapper">
										<button class="squarebutton" id="submit-feedback" type="submit" name="aft-submit-feedback" value="aft-submit-feedback"> '. __( 'Submit Ratings' ) . '</button>
									</div>
									<div id="formstatus"></div>	
								</div>
							</div>
						</div>
					</div>
					<input type="hidden" id="img-src" value="'.RTP_PLUGIN_DIR_IMG.'" />
					<input type="hidden" id="feedback-postid" name="feedback-postid" value="'.$postid.'" />
					<input type="hidden" id="feedback-sessionkey" name="feedback-sessionkey" value="'.$session_key.'" />
					<input type="hidden" id="feedback-datetime" name="feedback-datetime" value="'.$aft_data->rate_date.'" />';
				if ( is_page() ) {
					$display .= '<input type="hidden" id="feedback-ispage" name="feedback-ispage" value="true" />';
				} else {
					$display .= '<input type="hidden" id="feedback-ispage" name="feedback-ispage" value="false" />';
				}
					
		// This part will display the plugin together with the content.
		
		$display_content = $content;
		
		if ( $aft_is_enable == 'true' ) {
			if ( $aft_insertion == 'by-category' ) { // Show plugin by category
				$cat_opt_id = array();
				
				foreach( $options_category as $category ) {
					if ( $category > 0 ) {
						$cat_opt_id[] = intval($category);
					}
				}
			
				if ( is_single() && in_category( $cat_opt_id ) ) {
					if ( $aft_location == 'bottom' ) {
						$display_content = $content . $display; // Below the article
					} else {
						$display_content = $display . $content; // Above the article
					}
				}
			} else if ( $aft_insertion == 'by-page' ) { // Show plugin by page
				$page_opt_id = array();

				foreach( $options_page as $page ) {
					if ( $page > 0 ) {
						$page_opt_id[] = $page;
					}
				}
				
				// To avoid displaying the plugin in all page if page_opt_id is null.
				if( count($page_opt_id) == 0 ) $page_opt_id = 'no data';
				
				if ( is_page( $page_opt_id ) ) {
					if ( $aft_location == 'bottom' ) {
						$display_content = $content . $display; // Below the article
					} else {
						$display_content = $display . $content; // Above the article
					}
				}
			} else if ( $aft_insertion == 'page-category' ) { // Show plugin by page and category
				$cat_opt_id = array();
				$page_opt_id = array();
				
				foreach( $options_category as $category ) {
					if ( $category > 0 ) {
						$cat_opt_id[] = intval($category);
					}
				}
				
				foreach( $options_page as $page ) {
					if ( $page > 0 ) {
						$page_opt_id[] = $page;
					}
				}
				
				// To avoid displaying the plugin in all page if page_opt_id is null.
				if( count($page_opt_id) == 0 ) $page_opt_id = 'no data';
				
				if ( (is_single() && in_category( $cat_opt_id )) || is_page( $page_opt_id ) ) {
					if ( $aft_location == 'bottom' ) {
						$display_content = $content . $display; // Below the article
					} else {
						$display_content = $display . $content; // Above the article
					}
				}
			} else { // Show in all article
				if ( is_single() ) {
					if ( $aft_location == 'bottom' ) {
						$display_content = $content . $display; // Below the article
					} else {
						$display_content = $display . $content; // Above the article
					}
				}
			}
		}
		
		return $display_content; // return content.
	}
}
?>